#include "tailfile.h"

using namespace std;

#define MEASURE(F,V,ITS) start = clock(); \
	for (int i=0;i<ITS;i++) { \
		F; \
	} \
	finish = clock(); \
	cout << (double)(finish - start) << endl; \
	cout << "Time=" << (double)(finish - start) * 1000 / (ITS * CLOCKS_PER_SEC) << " ms (" << ITS << " tries)" << endl; \
	V = double(finish-start) * 1000/(ITS* CLOCKS_PER_SEC);

void readBigInts(int tries) {
	
	string sa,sb;
	cin >> sa;
	cin >> sb;
	long ls = (long)ceil((double)(sa.length()+sb.length())/((double)BASELEN));
	long n = 2;
	while (n < ls) {
		n = n*2;
	}
	InitializeFFT(n);
	BigInt* ba = new BigInt;
	InitializeBigInt(ba,(long)sa.length());
	for (unsigned int i=0;i<sa.length();i++) {
		ba->Coef[i]=sa[sa.length()-i-1]-'0';
	}
	ba->Size=(long)sa.length();

	BigInt* bb = new BigInt;
	InitializeBigInt(bb,(long)sb.length());
	for (unsigned int i=0;i<sb.length();i++) {
		bb->Coef[i]=sb[sb.length()-i-1]-'0';
	}
	bb->Size=(long)sb.length();

	
	BigInt* bc = new BigInt;
	InitializeBigInt(bc,ls+1);

	BigInt* bd = new BigInt;
	InitializeBigInt(bd,ls+1);

	clock_t start,finish;
	double quadmul,logmul;
	/*
	cout << "fft mul time per multop: ";
	MEASURE(MulBigInt(ba,bb,bc),logmul,(tries));
	*/
	cout << "normal mul time per multop: ";
	MEASURE(MulBigIntNoFFT(ba,bb,bd),quadmul,(tries));
/*
	cout << "lengths: " << ba->Size << " " << bb->Size << " " << bc->Size << endl;
	//PrintBigInt(ba);
	//PrintBigInt(bb);
	//PrintBigInt(bc);
	PrintBigInt(bd);
	cout << "compare: " << CompareBigInt(bc,bd) << endl;
	cout << "fft muls performed 1 : " << logmul/quadmul << " normal mul's performed" << endl;
	
	cout << "fft worst square error: " << FFTSquareWorstError << endl;
*/
	FreeBigInt(bd);
	delete bd;
	FreeBigInt(bc);
	delete bc;
	FreeBigInt(bb);
	delete bb;
	FreeBigInt(ba);
	delete ba;
	
}

int main( int argc , char *argv[ ]) {

	cin >> dec;
	cout << dec;
	
	int tries = 1;
	if (argc > 1) {
		tries = atoi(argv[1]);
		if (tries <= 0) {
			tries = 1;
		}
	}

	readBigInts(tries);
	return 0;

}