#ifndef BigInt_h
#define BigInt_h

#include "FFT.h"
#include <string>

typedef struct BigIntTag {
  Real * Coef;
  long Size, SizeMax;
} BigInt;

/* 
 * Decrease the base if the worst error in FFT become too large
 */

#define BASEFOUR
//#undef BASEFOUR

#if defined(BASEFOUR)
	#define BASE 100.
	#define invBASE 0.01
	#define BASELEN 2
#else
	#define BASE 10.
	#define invBASE 0.1
	#define BASELEN 1
#endif

void InitializeBigInt(BigInt * A, long MaxSize);
void FreeBigInt(BigInt * A);

void PrintBigInt(BigInt * A);

void UpdateBigInt(BigInt * A);
void AddBigInt(BigInt * A, BigInt * B, BigInt * C);
void MulBigInt(BigInt * A, BigInt * B, BigInt * C);
void MulBigIntNoFFT(BigInt * A, BigInt * B, BigInt * C);
//void Inverse(BigInt * A, BigInt * B, BigInt * tmpBigInt);


std::string ToStringBigInt(BigInt * A);
int CompareBigInt(BigInt * A, BigInt * B);

#endif